#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Tramvai
        {
        int  LgRute[11];   /* durata rutelor parcurse de acest tramvai */
        int  m;  /* Numarul de rute ale acestui tramvai  */
        long TimpTotal; /* timpul total pe care l-a parcurs tramvaiul pana la un moment dat  */
        int  pasager;  /* indica daca la momentul curenta asteapta sau nu un pasager    */
        } Tinfo;

int   n;   /* Numarul de tramvaie.  */
int   TimpSosire; /* Timpul la care soseste pasagerul   */
Tinfo T[21]; /* contine informatiile despre cele n tramvaie */

/***************************************************************************
Vom simula parcursul fiecarui tramvai pana la momentul sosirii pasagerului in statie.
Mai exact, vom aduna duratele rutelor tramvaielor pana cand timpul total parcurs este
>= timpul de sosire a pasagerului.
Pentru fiecare tramvai vom retine acest timp total parcurs.
Timpul de asteptare a pasagerului va fi egal cu diferenta dintre timpul total parcurs al
primului tramvai care soseste (cel care are timpul total minim) si timpul la care
soseste pasagerul
***************************************************************************/
//
int TimpAsteptare(void)
//determina cat timp trebuie sa astepte pasagerul tramvaiul urmator.
{
int   i, r;
long  TimpMin = 2000000001;
if (TimpSosire == 0) return 0;
for (i=0; i<n; i++)
    //vom considera fiecare tramvai si vom aduna duratele rutelor acestuia pana cand soseste un pasager
    {
     /* cat timp nu asteapta nici un pasager */
     while (!T[i].pasager)
           {
           for (r=0; r<T[i].m; r++)
               {
                T[i].TimpTotal+= T[i].LgRute[r];
                /* Daca asteapta un pasager  */
                if (T[i].TimpTotal >= TimpSosire)
                   {
                   /* Daca acesta este primul tramvai care se intoarce
                   de cand pasagerul a inceput sa astepte */
                   if (T[i].TimpTotal < TimpMin)
                      TimpMin = T[i].TimpTotal;

                   // a sosit pasagerul, retinem acest lucru si iesim din ciclu
                   T[i].pasager = 1;
                   break;
                   }
                }
           }
     }
  return (TimpMin-TimpSosire);
}


int main()
{
 int  i, r;
 FILE * fout=fopen("tramvai.out","w");
 FILE * fin=fopen("tramvai.in","r");
 fscanf(fin,"%d", &n);
 for (i=0; i<n; i++)
   {
    fscanf(fin,"%d",&T[i].m);
    T[i].TimpTotal = 0;
    T[i].pasager = 0;
    for (r = 0; r < T[i].m; r++)
        fscanf(fin, "%d", &T[i].LgRute[r]);
   }
 fscanf(fin,"%d", &TimpSosire);
 fprintf(fout,"%d\n", TimpAsteptare());
 return 0;
}
